//Get VideoManifestUrl
//Remove all after & incl.
//Store this video tag.
//When going to play video retrieve the VideoManifest.
//Use the file and take all after CMS/Resources
//http://vodfiles.dr.dk/CMS/Resources/dr.dk/NETTV/DR1/2011/09/4f907b9b-29d1-456d-868e-618089f8d2cc/05ffa78fbefc407db62da16b9c68d90e_1000.mp4

//Images
//http://www.dr.dk/nu/api/videos/18818/images/256x143.jpg
//http://www.dr.dk/nu/api/videos/18818/images/65x37.jpg
//http://www.dr.dk/nu/api/videos/18818/images/750x350.jpg

var widgetAPI = new Common.API.Widget();
var tvKey = new Common.API.TVKeyValue();
var pluginAPI = new Common.API.Plugin();


var Main =
{
    previousURL : null,
    currentURL  : null,
    state : "top",
    previousState : "top",
	
    windowTitle : "dr.dk/nu",
    nextWindowTitle : "dr.dk/nu",
    selectedVideo : 0,
    topSelect : 0,
    previousSelect : 0,
    mode : 0,
    mute : 0,
    inputMode : 4,
    sw : "",//Search word
    currentKey : null,
    searchTimeoutValue : 1000,
    infoTimeoutValue : 5000,
    infoMoveTimeoutValue : 10,
    splashTimeout : null,
    descriptionTimeout: null,
    goToLetterTimeout : null,
    settingsSelector: 0,
    settingsSelectorMax: 3,
    resumeSelect : true,
    UP : -1,
    DOWN : 1,

    WINDOW : 0,
    FULLSCREEN : 1,
    
    NMUTE : 0,
    YMUTE : 1,
    IGNORE_ENTER : false,
    IGNORE_ALL : false
}

/*
 * Show splash screen with copyright notice before starting
 */
/*
Main.onLoad = function()
{
    document.getElementById("main").style.display="none";
    document.getElementById("splash").style.display="block";
    splashTimeout = setTimeout("Main.init()", 500);
    widgetAPI.sendReadyEvent();
}
*/
Main.splashDone = function()
{
    clearTimeout(Main.splashTimeout);
    document.getElementById("main").style.display="block";
    document.getElementById("splash").style.display="none";
    Main.inputMode = 0;
}

Main.onLoad = function()
{
    if ( Player.init() && Audio.init() && Display.init() && Server.init() && Fileio.init())
    {
        Server.denmarktest();
        //Display.infoShow();
        Fileio.readSettings();
        Fileio.readHistory();
        Fileio.readFavorites();
        //alert(widgetAPI.getInfo("country"));
        Player.stopCallback = function()
        {
            //Remove info bar immediately
            Display.infoHideSub();
            //Show menu again
            Main.setWindowMode();
            Main.IGNORE_ENTER = false;
            Player.state = Player.STOPPED;
            alert("VideoID after play:" + Player.videoID + 
                " Cur:" + Player.curTime + 
                " Tot:" + Player.totTime);
            //Store the video in a history file
            Fileio.addHistory(Player.videoID, Player.curTime, Player.totTime);
            //Reenable screensaver
            pluginAPI.setOnScreenSaver();
        }
        //Data = FrontSelect;
        //Display.setVideoList( Data.videoNames );
        //Main.updateCurrentVideo();
        //Display.status("dr.dk not available - please retry laters");
        // Start retrieving data from server
        Server.dataReceivedCallback = function()
        {
            alert("dataReceivedCallback");
            document.getElementById("loadingIcon").style.display = "none";
            Main.selectedVideo = 0;
            Display.currentWindow = 0;
            //Update window title
            Main.windowTitle = Main.nextWindowTitle;
            Display.setTitle(Main.windowTitle);
            
            /* Use video information when it has arrived */
            alert("state :" + Main.state);
            switch (Main.state) {
                case "top":
                    Main.selectedVideo = Main.topSelect;
                    Display.currentWindow = Main.topSelect;
                    Display.setVideoList();
                    break;
                case "newest":
                case "mostviewed":
                case "lastchance":
                case "all":
                case "series":
                    for(i=0; i<TopData.length; i++){
                        if(TopData[i].state == Main.state){
                            Main.selectedVideo = TopData[i].position;
                            Display.currentWindow = TopData[i].cw;
                            alert("Read window settings");
                        }
                    }
                    Display.setVideoList();
                    break;
                default:
                    Display.setVideoList();
                    break;
            }
        }
			
        Server.videoLinkCallback = function(videoLink)
        {
            document.getElementById("loadingIcon").style.display = "none";
            if(videoLink){
                var videoLinkMod = Main.convertVideoLink(videoLink);
                if(videoLinkMod){
                    Player.setVideoURL(videoLinkMod);
                    //Player.setVideoURL("http://htpc:6544/Content/GetFile?StorageGroup=Recordings&FileName=1001_20110717002000.mpg");
                    //Player.setVideoURL("rtsp://streamer-01.dr.nordija.dk:80/dr1highmp4");
                    //Player.setVideoURL("rtsp://rtsplive.dr.dk:80/livestream12.sdp");
                    //Player.setVideoURL("http://vodfiles.dr.dk/CMS/Resources/dr.dk/NETTV/DR2/2012/04/75321f93-7c22-4c3b-acca-cd2194fef04f/1b5516ac83d0442bb54e4d86c6db52df_1000.mp4");
                    Main.IGNORE_ENTER = true;
                    Player.askResume();
                }
            }
        }
        Server.parseData(TopData, null);
        Display.setVideoList();
        Main.selectedVideo = 0;


        Display.setTitle(this.windowTitle);
        Main.splashTimeout = setTimeout("Main.splashDone()", 30000);
        widgetAPI.sendReadyEvent();
        // Enable key event processing
        Main.enableKeys();
        
    }
    else
    {
        alert("Failed to initialise");
    }
}

Main.onUnload = function()
{
    Player.deinit();
}

Main.updateCurrentVideo = function(move)
{
    //Player.setVideoURL( Data.getVideoURL(this.selectedVideo) );
    
    Display.setVideoListPosition(this.selectedVideo, move);
    //Use a timer to avoid updating the description and image when rolling through the list
    clearTimeout(Main.updateDescriptionTimeout);
    Main.updateDescriptionTimeout = setTimeout("Main.updateDescription()", 200);
        
}

Main.updateDescription = function()
{
    Display.setDescription( Data.getVideoTitle(this.selectedVideo), Data.getVideoDescription(this.selectedVideo));
    Display.setImage(Main.selectedVideo);
}
Main.enableKeys = function()
{
    document.getElementById("anchor").focus();
}

Main.keyDown = function()
{
    if(Main.IGNORE_ALL == false)
    {
        switch(this.inputMode){
            default:Main.keyDownNormal();break;
            case 1:Main.keyDownSettings();break;
            case 2:Main.keyDownSearch();break;
            case 4:Main.splashDone();break;
            case 5:Main.keyResumeQuestion();break;
        }
    }
    else
    {
        alert("Ignoring key press");
    }
}

Main.keyDownNormal = function()
{
    var keyCode = event.keyCode;
    alert("Key pressed: " + keyCode);
    
    switch(keyCode)
    {
        case tvKey.KEY_EXIT:
            widgetAPI.blockNavigation(event);
            alert("Quit widget");
            widgetAPI.sendReturnEvent();
            break;
        case tvKey.KEY_RETURN:
        case tvKey.KEY_PANEL_RETURN:
            widgetAPI.blockNavigation(event);
            alert("RETURN");
            Main.handleReturnKey();
            break;

        case tvKey.KEY_MENU:
            alert("MENU " + this.inputMode);
            Display.settingsShow();
            this.inputMode = 1;
            break;
        case tvKey.KEY_PLAY:
            alert("PLAY");
            this.handlePlayKey();
            break;
            
        case tvKey.KEY_STOP:
            alert("STOP");
            Player.stopVideo();
            break;
            
        case tvKey.KEY_PAUSE:
            alert("PAUSE");
            this.handlePauseKey();
            break;
            
        case tvKey.KEY_FF:
            alert("FF");
            if(Player.getState() != Player.PAUSED)
                Player.skipForwardVideo();
            break;
        
        case tvKey.KEY_RW:
            alert("RW");
            if(Player.getState() != Player.PAUSED)
                Player.skipBackwardVideo();
            break;

        case tvKey.KEY_VOL_UP:
        case tvKey.KEY_PANEL_VOL_UP:
            alert("VOL_UP");
            if(this.mute == 0)
                Audio.setRelativeVolume(0);
            break;
            
        case tvKey.KEY_VOL_DOWN:
        case tvKey.KEY_PANEL_VOL_DOWN:
            alert("VOL_DOWN");
            if(this.mute == 0)
                Audio.setRelativeVolume(1);
            break;      

        case tvKey.KEY_CH_UP:
            alert("CH_UP");
            if(this.inputMode == 0)
                document.getElementById("description").scrollTop -= 50;
            break;

        case tvKey.KEY_CH_DOWN:
            alert("CH_DOWN");
            if(this.inputMode == 0)
                document.getElementById("description").scrollTop += 50;
            break;
            
        case tvKey.KEY_LEFT:
            alert("LEFT");
            if(this.inputMode == 0)
                this.jumpPreviousVideo();
            break;
            
        case tvKey.KEY_RIGHT:
            alert("RIGHT");
            if(this.inputMode == 0)
                this.jumpNextVideo();
            break;
            
        case tvKey.KEY_UP:
            alert("UP");
            if(this.inputMode == 0)
                this.selectPreviousVideo(this.UP);
            break;       
            
        case tvKey.KEY_DOWN:
            alert("DOWN");
            if(this.inputMode == 0)
                this.selectNextVideo(this.DOWN);
            break;            

        case tvKey.KEY_ENTER:
        case tvKey.KEY_PANEL_ENTER:
            alert("ENTER");
            this.handleEnterKey();
            break;
        
        case tvKey.KEY_MUTE:
            alert("MUTE");
            this.muteMode();
            break;
            
        case tvKey.KEY_INFO:
            alert("INFO");
            this.handleInfoKey();
            break;
            
        case tvKey.KEY_1:
        case tvKey.KEY_2:
        case tvKey.KEY_3:
        case tvKey.KEY_4:
        case tvKey.KEY_5:
        case tvKey.KEY_6:
        case tvKey.KEY_7:
        case tvKey.KEY_8:
        case tvKey.KEY_9:
            Main.goToLetter(keyCode);
            break;
            
        default:
            alert("Unhandled key");
            break;
    }
}

Main.keyResumeQuestion = function()
{
    var keyCode = event.keyCode;
    alert("Key pressed: " + keyCode);
    alert("Time:" + Player.curTime);
    
    switch(keyCode)
    {
        case tvKey.KEY_EXIT:
            widgetAPI.blockNavigation(event);
            alert("EXIT");
            break;
        case tvKey.KEY_RETURN:
        case tvKey.KEY_PANEL_RETURN:
            widgetAPI.blockNavigation(event);
            alert("RETURN");
            Main.IGNORE_ENTER = false;
            Main.inputMode = 0;
            Display.resumeHide();
            Display.show();
            break;
            
        case tvKey.KEY_LEFT:
            alert("LEFT");
            if(Main.resumeSelect){
                if(Player.curTime > 60000){
                    Player.curTime = Player.curTime - 60000;
                }else{
                    Player.curTime = 0;
                }
                Display.resumeUpdate();
            }
            break;
            
        case tvKey.KEY_RIGHT:
            alert("RIGHT");
            if(Main.resumeSelect){
                Player.curTime = parseInt(Player.curTime, 10) + 60000;
                Display.resumeUpdate();
            }
            break;
        case tvKey.KEY_UP:
            alert("UP");
            Main.resumeSelect = true;
            Display.resumeUpdate();
            break;
        case tvKey.KEY_DOWN:
            alert("DOWN");
            Main.resumeSelect = false;
            Display.resumeUpdate();
            break;

        case tvKey.KEY_ENTER:
        case tvKey.KEY_PANEL_ENTER:
            alert("ENTER");
            Display.resumeHide();
            Main.inputMode = 0;
            if(Main.resumeSelect){
                Player.playVideo(Player.curTime/1000-5);
            }else{
                Player.playVideo(0);
            }
            break;
        
    }
}

Main.keyDownSettings = function()
{
    var keyCode = event.keyCode;
    alert("Key pressed: " + keyCode);
    
    switch(keyCode)
    {
        case tvKey.KEY_EXIT:
            widgetAPI.blockNavigation(event);
            alert("MENU " + this.inputMode);
            Display.settingsHide();
            this.inputMode = 0;
            Fileio.writeSettings(FileSettings);
            break;
        case tvKey.KEY_RETURN:
        case tvKey.KEY_PANEL_RETURN:
            widgetAPI.blockNavigation(event);
            alert("RETURN");
            Display.settingsHide();
            this.inputMode = 0;
            Fileio.writeSettings(FileSettings);
            break;

        case tvKey.KEY_MENU:
            alert("MENU " + this.inputMode);
            Display.settingsHide();
            this.inputMode = 0;
            Fileio.writeSettings(FileSettings);
            break;
        
        case tvKey.KEY_DOWN:
            Main.settingsSelector++;
            if(Main.settingsSelector>Main.settingsSelectorMax){
                Main.settingsSelector = 0;
            }
            Display.settingsShow();
            break;
        case tvKey.KEY_UP:
            Main.settingsSelector--;
            if(Main.settingsSelector<0){
                Main.settingsSelector = Main.settingsSelectorMax;
            }
            Display.settingsShow();
            break;
            
        case tvKey.KEY_LEFT:
            switch(Main.settingsSelector){
                case 0:FileSettings.initialBuffer -= 1;break;
                case 1:FileSettings.pendingBuffer -= 1;break;
                case 2:FileSettings.totalBuffer -= 1;break;
                case 3:FileSettings.searchLimit -= 1;break;
            }
            Display.settingsShow();
            break;
        case tvKey.KEY_RIGHT:
            switch(Main.settingsSelector){
                case 0:FileSettings.initialBuffer += 1;break;
                case 1:FileSettings.pendingBuffer += 1;break;
                case 2:FileSettings.totalBuffer += 1;break;
                case 3:FileSettings.searchLimit += 1;break;
            }
            Display.settingsShow();
            break;
        default:
            alert("Unhandled key");
            break;
    }
}

Main.keyDownSearch = function()
{
    var keyCode = event.keyCode;
    alert("Key pressed: " + keyCode);
    var action = 0;
    clearTimeout(Main.searchTimeout);
    
    switch(keyCode)
    {
        case tvKey.KEY_EXIT:
            widgetAPI.blockNavigation(event);
            Display.searchHide();
            break;
        case tvKey.KEY_RETURN:
        case tvKey.KEY_PANEL_RETURN:
            widgetAPI.blockNavigation(event);
            action = 3;
            break;
        case tvKey.KEY_ENTER:
            //Remove trailing underscore
            if(Main.sw.charAt(Main.sw.length-1) == '_'){
                Main.sw = Main.sw.substring(0, Main.sw.length-1);
            }
            if(Main.sw != null && Main.sw != ""){
                URL = "http://www.dr.dk/nu/api/search/" + escape(Main.sw) + "?mode=both&limit=" + FileSettings.searchLimit;
                alert("search URL:" + URL);
                Main.nextWindowTitle = Main.windowTitle + " > " + Main.sw;
                this.state = "search";//set next state
                Server.fetchVideoList(URL, "list"); /* Request video information from server */
            }
            Display.searchHide();
            break;
        case tvKey.KEY_0:
            Main.searchTimeout = setTimeout("Main.keyClear()", Main.searchTimeoutValue);
            Main.currentKey = ' ';action = 1;
            break;
        case tvKey.KEY_1:
            Main.searchTimeout = setTimeout("Main.keyClear()", Main.searchTimeoutValue);
            switch(Main.currentKey){
                case '.':Main.currentKey = ',';action = 2;break;
                case ',':Main.currentKey = ';';action = 2;break;
                case ';':Main.currentKey = '@';action = 2;break;
                case '@':Main.currentKey = '1';action = 2;break;
                case '1':Main.currentKey = '.';action = 2;break;
                default:Main.currentKey = '.';action = 1;break;
            }
            break;
        case tvKey.KEY_2:
            Main.searchTimeout = setTimeout("Main.keyClear()", Main.searchTimeoutValue);
            switch(Main.currentKey){
                case 'a':Main.currentKey = 'b';action = 2;break;
                case 'b':Main.currentKey = 'c';action = 2;break;
                case 'c':Main.currentKey = '2';action = 2;break;
                //case '�': Main.currentKey = '2'; action = 2; break;
                case '2':Main.currentKey = 'a';action = 2;break;
                default:Main.currentKey = 'a';action = 1;break;
            }
            break;
        case tvKey.KEY_3:
            Main.searchTimeout = setTimeout("Main.keyClear()", Main.searchTimeoutValue);
            switch(Main.currentKey){
                case 'd':Main.currentKey = 'e';action = 2;break;
                case 'e':Main.currentKey = 'f';action = 2;break;
                case 'f':Main.currentKey = '3';action = 2;break;
                case '3':Main.currentKey = 'd';action = 2;break;
                default:Main.currentKey = 'd';action = 1;break;
            }
            break;
        case tvKey.KEY_4:
            Main.searchTimeout = setTimeout("Main.keyClear()", Main.searchTimeoutValue);
            switch(Main.currentKey){
                case 'g':Main.currentKey = 'h';action = 2;break;
                case 'h':Main.currentKey = 'i';action = 2;break;
                case 'i':Main.currentKey = '4';action = 2;break;
                case '4':Main.currentKey = 'g';action = 2;break;
                default:Main.currentKey = 'g';action = 1;break;
            }
            break;
        case tvKey.KEY_5:
            Main.searchTimeout = setTimeout("Main.keyClear()", Main.searchTimeoutValue);
            switch(Main.currentKey){
                case 'j':Main.currentKey = 'k';action = 2;break;
                case 'k':Main.currentKey = 'l';action = 2;break;
                case 'l':Main.currentKey = '5';action = 2;break;
                case '5':Main.currentKey = 'j';action = 2;break;
                default:Main.currentKey = 'j';action = 1;break;
            }
            break;
        case tvKey.KEY_6:
            Main.searchTimeout = setTimeout("Main.keyClear()", Main.searchTimeoutValue);
            switch(Main.currentKey){
                case 'm':Main.currentKey = 'n';action = 2;break;
                case 'n':Main.currentKey = 'o';action = 2;break;
                case 'o':Main.currentKey = '6';action = 2;break;
                case '6':Main.currentKey = 'm';action = 2;break;
                default:Main.currentKey = 'm';action = 1;break;
            }
            break;
        case tvKey.KEY_7:
            Main.searchTimeout = setTimeout("Main.keyClear()", Main.searchTimeoutValue);
            switch(Main.currentKey){
                case 'p':Main.currentKey = 'q';action = 2;break;
                case 'q':Main.currentKey = 'r';action = 2;break;
                case 'r':Main.currentKey = 's';action = 2;break;
                case 's':Main.currentKey = '7';action = 2;break;
                case '7':Main.currentKey = 'p';action = 2;break;
                default:Main.currentKey = 'p';action = 1;break;
            }
            break;
        case tvKey.KEY_8:
            Main.searchTimeout = setTimeout("Main.keyClear()", Main.searchTimeoutValue);
            switch(Main.currentKey){
                case 't':Main.currentKey = 'u';action = 2;break;
                case 'u':Main.currentKey = 'v';action = 2;break;
                case 'v':Main.currentKey = '8';action = 2;break;
                case '8':Main.currentKey = 't';action = 2;break;
                default:Main.currentKey = 't';action = 1;break;
            }
            break;
        case tvKey.KEY_9:
            Main.searchTimeout = setTimeout("Main.keyClear()", Main.searchTimeoutValue);
            switch(Main.currentKey){
                case 'w':Main.currentKey = 'x';action = 2;break;
                case 'x':Main.currentKey = 'y';action = 2;break;
                case 'y':Main.currentKey = 'z';action = 2;break;
                case 'z':Main.currentKey = '9';action = 2;break;
                case '9':Main.currentKey = 'w';action = 2;break;
                default:Main.currentKey = 'w';action = 1;break;
            }
            break;
        default:
            alert("Unhandled key");
            break;
    }
    //Remove trailing underscore
    if(Main.sw.charAt(Main.sw.length-1) == '_'){
        Main.sw = Main.sw.substring(0, Main.sw.length-1);
    }
    switch(action){
        case 1:
            Main.sw = Main.sw + Main.currentKey;
            document.getElementById("search").innerHTML = Main.sw;
            alert("Added:" + Main.currentKey);
            break;
        case 2:
            Main.sw = Main.sw.substring(0, Main.sw.length-1) + Main.currentKey;
            document.getElementById("search").innerHTML = Main.sw;
            alert("changed:" + Main.currentKey);
            break;
        case 3:
            if(Main.sw.length > 0){
                Main.sw = Main.sw.substring(0, Main.sw.length-1) + "_";
                document.getElementById("search").innerHTML = Main.sw;
                alert("delete:");
            }else{
                Display.searchHide();
            }
            break;
    }
}

Main.keyClear = function()
{
    alert("keyclear");
    Main.currentKey = null;
    Main.sw = Main.sw + "_";
    document.getElementById("search").innerHTML = Main.sw;
}

Main.handleReturnKey = function()
{
    switch ( Player.getState() )
    {
        case Player.PAUSED:
        case Player.PLAYING:
        case Player.FORWARD:
        case Player.REWIND:
        case Player.PLAYING:
            Player.stopVideo();
            break;
        case Player.STOPPED:
            alert("return from state " + this.state);
            switch (this.state) {
                case "top":
                    alert("Ignoring return key on top level");
                    break;
                case "newest":
                case "mostviewed":
                case "lastchance":
                case "spot":
                case "highlight":
                case "all":
                case "series":
                case "tvavisen":
                case "deadline":
                case "search":
                    // Store window position
                    for(i=0; i<TopData.length; i++){
                        if(TopData[i].state == Main.state){
                            TopData[i].position = Main.selectedVideo;
                            TopData[i].cw = Display.currentWindow;
                            alert("Storing " + Main.state + " cw:" + Display.currentWindow + "pos:" + Main.selectedVideo);
                        }
                    }
                    Server.parseData(TopData, null);
                    this.selectedVideo = Main.topSelect;
                    Display.currentWindow = Main.topSelect;
                    Display.setVideoList();
                    this.windowTitle = "dr.dk/nu";//this.windowTitle.substring(0, this.windowTitle.lastIndexOf(" > "));
                    //Update headline
                    Display.setTitle(this.windowTitle);
                    this.state = "top";
                    break;
                case "subseries":
                    alert("return from subseries");
                    URL = TopData[2].link;
                    if(URL != null){
                        Main.nextWindowTitle = "dr.dk/nu" + " > " + TopData[2].title;
                        this.state = TopData[2].state;//set next state
                        Server.fetchVideoList(URL, "list"); /* Request video information from server */
                        //Update headline
                        Display.setTitle(this.windowTitle);
                    }
                    break;
                default:
                    alert("Going back from unknown state");
                    break;
            }
    }
}
Main.handlePlayKey = function()
{
    switch ( Player.getState() )
    {
        case Player.STOPPED:
            Player.playVideo();
            break;
            
        case Player.PAUSED:
            Player.resumeVideo();
            break;
            
        default:
            alert("Ignoring play key, not in correct state");
            break;
    }
}

Main.handlePauseKey = function()
{
    switch ( Player.getState() )
    {
        case Player.PLAYING:
            Player.pauseVideo();
            break;
        
        case Player.PAUSED:
            Player.resumeVideo();
            break;
        
        default:
            alert("Ignoring pause key, not in correct state");
            break;
    }
}

Main.goToLetter = function(keyCode)
{
    var listSize = Data.getVideoCount();
    switch(keyCode)
    {
        case tvKey.KEY_1:
            switch(Main.currentKey){
                case '1':Main.currentKey = '1';break;
                default:Main.currentKey = '1';break;
            }
            break;
        case tvKey.KEY_2:
            switch(Main.currentKey){
                case 'a':Main.currentKey = 'b';break;
                case 'b':Main.currentKey = 'c';break;
                case 'c':Main.currentKey = '2';break;
                case '2':Main.currentKey = 'a';break;
                default:Main.currentKey = 'a';break;
            }
            break;
        case tvKey.KEY_3:
            switch(Main.currentKey){
                case 'd':Main.currentKey = 'e';break;
                case 'e':Main.currentKey = 'f';break;
                case 'f':Main.currentKey = '3';break;
                case '3':Main.currentKey = 'd';break;
                default:Main.currentKey = 'd';break;
            }
            break;
        case tvKey.KEY_4:
            switch(Main.currentKey){
                case 'g':Main.currentKey = 'h';break;
                case 'h':Main.currentKey = 'i';break;
                case 'i':Main.currentKey = '4';break;
                case '4':Main.currentKey = 'g';break;
                default:Main.currentKey = 'g';break;
            }
            break;
        case tvKey.KEY_5:
            switch(Main.currentKey){
                case 'j':Main.currentKey = 'k';break;
                case 'k':Main.currentKey = 'l';break;
                case 'l':Main.currentKey = '5';break;
                case '5':Main.currentKey = 'j';break;
                default:Main.currentKey = 'j';break;
            }
            break;
        case tvKey.KEY_6:
            switch(Main.currentKey){
                case 'm':Main.currentKey = 'n';break;
                case 'n':Main.currentKey = 'o';break;
                case 'o':Main.currentKey = '6';break;
                case '6':Main.currentKey = 'm';break;
                default:Main.currentKey = 'm';break;
            }
            break;
        case tvKey.KEY_7:
            switch(Main.currentKey){
                case 'p':Main.currentKey = 'q';break;
                case 'q':Main.currentKey = 'r';break;
                case 'r':Main.currentKey = 's';break;
                case 's':Main.currentKey = '7';break;
                case '7':Main.currentKey = 'p';break;
                default:Main.currentKey = 'p';break;
            }
            break;
        case tvKey.KEY_8:
            switch(Main.currentKey){
                case 't':Main.currentKey = 'u';break;
                case 'u':Main.currentKey = 'v';break;
                case 'v':Main.currentKey = '8';break;
                case '8':Main.currentKey = 't';break;
                default:Main.currentKey = 't';break;
            }
            break;
        case tvKey.KEY_9:
            switch(Main.currentKey){
                case 'w':Main.currentKey = 'x';break;
                case 'x':Main.currentKey = 'y';break;
                case 'y':Main.currentKey = 'z';break;
                case 'z':Main.currentKey = '9';break;
                case '9':Main.currentKey = 'w';break;
                default:Main.currentKey = 'w';break;
            }
            break;
        default:
            alert("Unhandled key");
            break;
    }
    alert("Char at title:" + Data.getVideoTitle(this.selectedVideo).charAt(0));
    Display.status("Spring til " + Main.currentKey);
    //Use a timer to allow the user to type the letter before the jump is performed
    clearTimeout(Main.goToLetterTimeout);
    Main.goToLetterTimeout = setTimeout("Main.goToLetterTimer()", 1000);
}

Main.goToLetterTimer = function()
{
    var listSize = Data.getVideoCount();
    document.getElementById("loadingIcon").style.display = "block";
    var i = 0;
    while(Main.currentKey != Data.getVideoTitle(this.selectedVideo).toLowerCase().charAt(0) && i++ < listSize){
        alert("Char:" + Data.getVideoTitle(this.selectedVideo).toLowerCase().charAt(0) + "  Key:" + Main.currentKey + " i:" + i);
        this.selectNextVideo(this.DOWN);
    }
    Display.status("");
    document.getElementById("loadingIcon").style.display = "none";
}

Main.selectNextVideo = function(down)
{
    this.selectedVideo = (this.selectedVideo + 1) % Data.getVideoCount();
    this.updateCurrentVideo(down);
}

Main.jumpNextVideo = function()
{
    if( (this.selectedVideo+9) > (Data.getVideoCount()-1) )
    {
        this.selectedVideo = Data.getVideoCount() -1;
        alert("jump maxed");
    }else{
        this.selectedVideo += 9;
    }
    this.updateCurrentVideo(9);
}
Main.jumpPreviousVideo = function()
{
    if(this.selectedVideo-9 < 0 )
    {
        this.selectedVideo = 0;
    }else{
        this.selectedVideo -= 9;
    }
    this.updateCurrentVideo(-9);
}

Main.selectPreviousVideo = function(up)
{
    if (--this.selectedVideo < 0)
    {
        this.selectedVideo += Data.getVideoCount();
    }
    this.updateCurrentVideo(up);
}

Main.setFullScreenMode = function()
{
    if (this.mode != this.FULLSCREEN)
    {
        Display.hide();
        
        //Player.setFullscreen();
        
        this.mode = this.FULLSCREEN;
    }
}

Main.setWindowMode = function()
{
    if (this.mode != this.WINDOW)
    {
        Display.show();
        
        //Player.setWindow();
        
        this.mode = this.WINDOW;
    }
}
/*
Main.infoTimeoutFunc = function()
{
    Display.infoHide();
}
*/
Main.handleInfoKey = function()
{
    alert("infokey");
    /*
    clearTimeout(Main.infoTimeout);
    Main.infoTimeout = setTimeout("Main.infoTimeoutFunc()", Main.infoTimeoutValue);
    */
    Display.infoShow();
    Display.infoHide();
}
Main.handleEnterKey = function()
{
    if(Main.IGNORE_ENTER == false && (Player.state == Player.STOPPED) ) {
        //Update values based on selection
        this.previousURL = this.currentURL;//Store old URL for use of return key
        this.previousState = this.state;
        this.previousSelect = this.selectedVideo;
        
        switch (this.state) {
            case "top":
                alert("state:top");
                URL = Data.link[this.selectedVideo];
                if(Data.state[this.selectedVideo] == "search"){
                    Display.searchShow();
                }else{
                    if(URL != null){
                        Main.topSelect = this.selectedVideo;
                        Main.nextWindowTitle = Main.windowTitle + " > " + Data.title[this.selectedVideo];
                        this.state = Data.state[this.selectedVideo];//set next state
                        if( (Data.state[this.selectedVideo] == "tvavisen") ||(Data.state[this.selectedVideo] == "deadline") ){
                            Server.fetchVideoList(URL, "modtitle"); /* Request video information from server */
                        }else{
                            Server.fetchVideoList(URL, "list"); /* Request video information from server */
                        }
                        //Update headline
                        Display.setTitle(this.windowTitle);
                    }
                }
                break;
            case "newest":
            case "mostviewed":
            case "favoritter":
            case "lastchance":
            case "all":
            case "subseries":
            case "tvavisen":
            case "deadline":
            case "search":
                Player.videoID = Data.getVideoID(Main.selectedVideo);
                URL = Data.videoManifestUrl[this.selectedVideo];
                if(URL != null){
                    Server.fetchVideoList(URL, "manifest"); /* Request video information from server */
                }else{
                    if(Data.id[this.selectedVideo] != null){
                        URL = "http://www.dr.dk/nu/api/videos/" + Data.id[this.selectedVideo];
                        Server.fetchVideoList(URL, "id"); /* Request video information from server */
                    }
                }
                break;

            case "series":
                for(i=0; i<TopData.length; i++){
                    if(TopData[i].state == Main.state){
                        TopData[i].position = Main.selectedVideo;
                        TopData[i].cw = Display.currentWindow;
                        alert("Storing position:" + Main.selectedVideo);
                    }
                }
                alert("state:series");
                Main.nextWindowTitle = Main.windowTitle + " > " + Data.title[this.selectedVideo];
                URL = Data.link[this.selectedVideo];
                this.state = "subseries";//set next state
                //Update headline
                Display.setTitle(this.windowTitle);
                Server.fetchVideoList(URL, "list"); /* Request video information from server */
                // Store window position
            break;
            default:
                alert("default state");
                break;
        }
    }else{
        alert("Enter ignore:"+ Main.IGNORE_ENTER + " Player.State:" + Player.state);
        alert("Ignoring Enter - not correct state");
    }
}


Main.setMuteMode = function()
{
    if (this.mute != this.YMUTE)
    {
        //var volumeElement = document.getElementById("volumeInfo");
        //Audio.plugin.SetSystemMute(true);
        Audio.plugin.SetUserMute(true);
        //document.getElementById("volumeBar").style.backgroundImage = "url(Images/videoBox/muteBar.png)";
        //document.getElementById("volumeIcon").style.backgroundImage = "url(Images/videoBox/mute.png)";
        //widgetAPI.putInnerHTML(volumeElement, "MUTE");
        this.mute = this.YMUTE;
    }
}

Main.noMuteMode = function()
{
    if (this.mute != this.NMUTE)
    {
        Audio.plugin.SetUserMute(false); 
        //document.getElementById("volumeBar").style.backgroundImage = "url(Images/videoBox/volumeBar.png)";
        //document.getElementById("volumeIcon").style.backgroundImage = "url(Images/videoBox/volume.png)";
        //Display.setVolume( Audio.getVolume() );
        this.mute = this.NMUTE;
    }
}

Main.muteMode = function()
{
    switch (this.mute)
    {
        case this.NMUTE:
            this.setMuteMode();
            break;
            
        case this.YMUTE:
            this.noMuteMode();
            break;
            
        default:
            alert("ERROR: unexpected mode in muteMode");
            break;
    }
}
Main.convertVideoLink = function(videoLink)
{
    var firstCut = videoLink.indexOf("CMS/Resources/dr.dk/");
    var lastCut = videoLink.lastIndexOf("?");
    alert("videoLink before transform: " + videoLink);
    if( (firstCut >= 0) && (lastCut > firstCut) ){
        alert("OK");
        var videoLinkMod = "http://vodfiles.dr.dk/" + videoLink.substring(firstCut, lastCut);
        alert("videoLink after transform: " + videoLinkMod);
        return videoLinkMod;
    }
    else{
        return null;
    }
}
