var Player =
{
    plugin : null,
    state : -1,
    skipTimeoutValue : 3000,
    skipAmount: 0,
    stopCallback : null,    /* Callback function to be set by client */
    originalSource : null,
    curTime : 0,
    totTime : 0,
    videoID : 0,
    
    STOPPED : 0,
    PLAYING : 1,
    PAUSED : 2,  
    FORWARD : 3,
    REWIND : 4
}

Player.init = function()
{
    var success = true;
    this.state = this.STOPPED;
    
    this.plugin = document.getElementById("pluginPlayer");
    
    if (!this.plugin)
    {
        alert("Unable to get plugin");
        success = false;
    }
    
    //this.plugin.SetDisplayArea(0, 0, 960, 540);



    this.plugin.OnCurrentPlayTime = 'Player.setCurTime';
    this.plugin.OnStreamInfoReady = 'Player.onStreamInfoReady';
    this.plugin.OnBufferingStart = 'Player.onBufferingStart';
    this.plugin.OnBufferingProgress = 'Player.onBufferingProgress';
    this.plugin.OnBufferingComplete = 'Player.onBufferingComplete';  
    this.plugin.OnRenderingComplete = 'Player.onRenderingComplete';
    this.plugin.OnNetworkDisconnected = 'Player.onNetworkDisconnected';
    this.plugin.OnConnectionFailed = 'Player.onConnectionFailed';
    this.plugin.OnRenderError = 'Player.onRenderError';
    this.plugin.OnStreamNotFound = 'Player.onStreamNotFound';
    return success;
}

Player.deinit = function()
{
    alert("Player deinit !!! " );
      
    if (this.plugin)
    {
        this.plugin.Stop();
    }
}
/*
Player.setWindow = function()
{
    this.plugin.SetDisplayArea(458, 58, 472, 270);
}

Player.setFullscreen = function()
{
    this.plugin.SetDisplayArea(0, 0, 960, 540);
}
*/
Player.setVideoID = function(id)
{
    this.videoID = id;
    alert("VideoID = " + this.videoID);
}
Player.setVideoURL = function(url)
{
    this.url = url;
    alert("URL = " + this.url);
}

Player.askResume = function()
{
    var idx = Fileio.lookupHistory(this.videoID);
    alert("History found at " + idx + ". Done:" + History.done[idx])
    //Playback is not done
    if((idx != -1) && !History.done[idx]){
    //if(true){
        alert("History found at " + idx + ". Resuming at " + History.time[idx])
        //Here we need to ask the user if he want to resume the playback
        Player.curTime = History.time[idx];
        //Player.curTime = 450000;
        Main.inputMode = 5;
        Display.resumeShow();
    }else{
        Player.curTime = 0;
        Player.playVideo(0);
    }
}

Player.playVideo = function(time)
{
    if (this.url == null)
    {
        alert("No videos to play");
    }
    else
    {
        this.state = this.PLAYING;
        Display.status("Play");
        //this.setWindow();
        Audio.plugin.SetSystemMute(false);
        //Disable screensaver
        pluginAPI.setOffScreenSaver();
        
        //Specifies the total buffer size for streaming in bytes.
        success = this.plugin.SetTotalBufferSize(1024*1024*FileSettings.totalBuffer);
        alert("SetTotalBufferSize set : " + success);
        success = this.plugin.SetPendingBuffer(1024*1024*FileSettings.pendingBuffer);
        alert("SetPendingBuffer set : " + success);
        success = this.plugin.SetInitialBuffer(1024*1024*FileSettings.initialBuffer);
        alert("SetInitialBuffer set : " + success);
        Player.totTime = 0;
        if(time == 0){
            alert("Play from start");
            this.plugin.Play( this.url );
        }else{
            alert("Resume from " + time);
            //Resume play
            //Note that the time for ResumePlay is in seconds
            this.plugin.ResumePlay( this.url, time);
        }
        this.plugin.SetDisplayArea(0, 0, 960, 540);
        widgetAPI.putInnerHTML(document.getElementById("bufferstatus"), "Forbinder ...");
        Display.infoShow();
        //document.getElementById("bufferstatus").style.display = "block";
    }
}

Player.time2string = function(time){
    hour = parseInt(time/3600000);
    min = parseInt((time/60000)%60);
    sec = parseInt((time/1000)%60);
    var str = "";
    
    //Seconds
    str = sec;
    if(sec<10){
        str = "0" + str;
    }
    //Minuttes
    str = min + ":" + str;
    if( (min<10) && (hour > 0)){
        str = "0" + str;
    }
    if(hour > 0){
        str = hour + ":" + str;
    }
    return str;
}


Player.pauseVideo = function()
{
    this.state = this.PAUSED;
    Display.status("Pause");
    
    //widgetAPI.putInnerHTML(document.getElementById("bufferstatus"), "Pause " + Player.time2string(this.curTime) + " of " + Player.time2string(Player.plugin.GetDuration()));
    //widgetAPI.putInnerHTML(document.getElementById("bufferstatus"), "Pause " + Player.time2string(this.curTime));
    widgetAPI.putInnerHTML(document.getElementById("bufferstatus"), "Pause");
    Display.infoShow();
    //document.getElementById("bufferstatus").style.display = "block";
    this.plugin.Pause();
}

Player.stopVideo = function()
{
    if (this.state != this.STOPPED)
    {
        this.state = this.STOPPED;
        Display.status("Stop");
        this.plugin.Stop();
        if (this.stopCallback)
        {
            this.stopCallback();
        }
    }
    else
    {
        alert("Ignoring stop request, not in correct state");
    }
}

Player.resumeVideo = function()
{
    this.state = this.PLAYING;
    Display.status("Resume");
    widgetAPI.putInnerHTML(document.getElementById("bufferstatus"), "");
    //document.getElementById("bufferstatus").style.display = "none
    Display.infoHide();
    this.plugin.Resume();
}

Player.skip = function()
{
    alert("Skip " + this.skipAmount + " min");
    if(this.skipAmount > 0 ){
        this.state = this.FORWARD;
        this.plugin.JumpForward(60*this.skipAmount);
    }else if(this.skipAmount < 0){
        this.state = this.REWIND;
        this.plugin.JumpBackward(-60*this.skipAmount);
    }
    this.skipAmount = 0;
}
Player.skipForwardVideo = function()
{
    if(this.state != this.STOPPED)
    {
        clearTimeout(this.skipTimeout);
        this.skipTimeout = setTimeout("Player.skip()", this.skipTimeoutValue);
        this.skipAmount++;
        widgetAPI.putInnerHTML(document.getElementById("bufferstatus"), "Skip " + this.skipAmount + " min");
        Display.infoShow();
        //document.getElementById("bufferstatus").style.display = "block";
    }
}

Player.skipBackwardVideo = function()
{
    if(this.state != this.STOPPED)
    {
        clearTimeout(this.skipTimeout);
        this.skipTimeout = setTimeout("Player.skip()", this.skipTimeoutValue);
        this.skipAmount--;
        widgetAPI.putInnerHTML(document.getElementById("bufferstatus"), "Skip " + this.skipAmount + " min");
        Display.infoShow();
        //document.getElementById("bufferstatus").style.display = "block";
    }
}

Player.getState = function()
{
    return this.state;
}

// Global functions called directly by the player 

Player.onBufferingStart = function()
{
    Main.setFullScreenMode();//Go directly to full screen
    Display.status("Henter ...");
    widgetAPI.putInnerHTML(document.getElementById("bufferstatus"), "Henter ...");
    Display.infoShow();
    //document.getElementById("bufferstatus").style.display = "block";
}

Player.onBufferingProgress = function(percent)
{
    Display.status("Henter " + percent + "%");
    //Show bufferstatus
    widgetAPI.putInnerHTML(document.getElementById("bufferstatus"), "Henter " + percent + "%");
    Display.infoShow();
    //document.getElementById("bufferstatus").style.display = "block";
}

Player.onBufferingComplete = function()
{
    alert("Buffering complete");
    //Avoid problems due to this call back being active if video is stopped during buffering
    if(this.state != this.STOPPED)
    {
        this.state = this.PLAYING;
        Display.status("");
        widgetAPI.putInnerHTML(document.getElementById("bufferstatus"), "");
        //Hide bufferstatus
        Display.infoHide();
        //document.getElementById("bufferstatus").style.display = "none";
    }
}
Player.onRenderingComplete = function()
{
    alert("Rendering complete");
    this.state = this.STOPPED;
    Display.status("");
    this.plugin.Stop();
    if (this.stopCallback)
    {
        this.stopCallback();
    }
}

Player.onNetworkDisconnected = function()
{
    alert("Network disconnected");
    this.state = this.STOPPED;
    Display.status("Netv&aelig;rk afbrudt");
    this.plugin.Stop();
    if (this.stopCallback)
    {
        this.stopCallback();
    }
}
Player.onConnectionFailed = function()
{
    alert("Connection failed");
    this.state = this.STOPPED;
    Display.status("Forbindelsesfejl");
    this.plugin.Stop();
    if (this.stopCallback)
    {
        this.stopCallback();
    }
}
Player.onRenderError = function(errorcode)
{
    alert("Render error " + errorcode);
    this.state = this.STOPPED;
    Display.status("Render fejl");
    this.plugin.Stop();
    if (this.stopCallback)
    {
        this.stopCallback();
    }
}
Player.onStreamNotFound = function()
{
    alert("Stream not found");
    this.state = this.STOPPED;
    Display.status("Video ikke fundet");
    this.plugin.Stop();
    if (this.stopCallback)
    {
        this.stopCallback();
    }
}

Player.setCurTime = function(time)
{
    this.curTime = time;
    //alert("curTime:" + this.curTime);
}

Player.onStreamInfoReady = function()
{
    this.totTime = Player.plugin.GetDuration();
    alert("totalTime:" + this.totTime);
    var width = Player.plugin.GetVideoWidth();
    var height = Player.plugin.GetVideoHeight();
    alert("Video size: " + width + "x" + height);
    var bps=Player.plugin.GetCurrentBitrates(); 
    alert("Current bitrate:" + bps);
    var bitratesInfo=Player.plugin.GetAvailableBitrates();
    alert("Available bitrates:" + bitratesInfo);
}

onServerError = function()
{
    Display.status("Serverfejl");
}

OnNetworkDisconnected = function()
{
    Display.status("Netv&aelig;rk afbrudt");
}

getBandwidth = function(bandwidth) { 
    alert("getBandwidth " + bandwidth);
}

onDecoderReady = function() { 
    alert("onDecoderReady");
}

onRenderError = function() { 
    alert("onRenderError");
}

stopPlayer = function()
{
    Player.stopVideo();
}

