var Server =
{
    /* Callback function to be set by client */
    dataReceivedCallback : null,
    videoLinkCallback : null,
    XHRObj : null
}

Server.init = function()
{
    var success = true;

    if (this.XHRObj)
    {
        this.XHRObj.destroy();  // Save memory
        this.XHRObj = null;
    }
    
    return success;
}

Server.fetchVideoList = function(URL, linkType)
{
    if (this.XHRObj == null)
    {
        this.XHRObj = new XMLHttpRequest();
    }
    
    if (this.XHRObj)
    {
        this.XHRObj.onreadystatechange = function()
        {
            Main.IGNORE_ALL = true;
            alert("XHR state:" + Server.XHRObj.readyState);
                        
            switch (Server.XHRObj.readyState) {
                case 1:
                    Display.status("Opretter forbindelse");
                    break;
                case 2:
                    Display.status("Venter p&aring; data");
                    break;
                case 3:
                    Display.status("Modtager data");
                    break;

                case 4:
                    Main.IGNORE_ALL = false;
                    Display.status("");
                    if( (linkType == "list") || (linkType == "modtitle"))
                    {
                        Server.createVideoList(linkType);
                    }
                    else if(linkType == "manifest")
                    {
                        Server.createVideoLink();
                    }
                    else if(linkType == "id")
                    {
                        Server.getVideoID();
                    }
                default:
                    break;
            }
        }
        alert("fetchVideoList : " + URL + " Linktype:" + linkType);
        document.getElementById("loadingIcon").style.display = "block";
        this.XHRObj.open("GET", URL, true);
        this.XHRObj.send(null);
    }
    else
    {
        alert("Failed to create XHR");
    }
}
Server.denmarktest = function()
{
    if (this.XHRObj == null)
    {
        this.XHRObj = new XMLHttpRequest();
    }

    if (this.XHRObj)
    {
        this.XHRObj.onreadystatechange = function()
        {
            //alert("XHR state:" + Server.XHRObj.readyState);

            switch (Server.XHRObj.readyState) {

                case 4:
                    if (Server.XHRObj.status != 200)
                    {
                        switch (Server.XHRObj.status){
                            case 503:Display.status("dr.dk not available - please retry later");break;
                            default:Display.status("Server Error " + this.XHRObj.status);
                        }
                    }
                    else
                    {
                        alert("DK:" + Server.XHRObj.responseText);
                        if(Server.XHRObj.responseText != "true"){
                            Display.status("Ikke dansk IP-adresse - nogle videoer er utilgængelige!");
                        }
                    }
                default:
                    break;
            }
        }
        this.XHRObj.open("GET", "http://www.dr.dk/nu/api/estoyendinamarca", true);
        this.XHRObj.send(null);
    }
    else
    {
        alert("Failed to create XHR");
    }
}

Server.getVideoID = function()
{
    if (this.XHRObj.status != 200)
    {
        switch (this.XHRObj.status){
            case 503:Display.status("dr.dk not available - please retry later");break;
            default:Display.status("Server Error " + this.XHRObj.status);
        }
    }
    else
    {
        var jsontext = this.XHRObj.responseText;
        if(!jsontext){
            alert("Failed to get valid input");
        }
        else {
            alert("Got video ID");
            var json = JSON.parse("[ " + jsontext + " ]");
            //var json = JSON.parse(jsontext);
            alert("json len:" + json.length + " : " + json);
            for(i=0;i<json.length;i++){
                for(x in json[i]){
                    alert(x + " : " + json[i][x]);
                    if(x=="videoManifestUrl"){
                        alert("Got manifest : " + json[i].videoManifestUrl);
                        Server.fetchVideoList(json[i].videoManifestUrl, "manifest"); /* Request video information from server */
                    }
                    if(x=="id"){
                        Player.setVideoID(json[i][x]);
                    }                    
                }
            }
        }
    }
}

Server.createVideoLink = function()
{
    if (this.XHRObj.status != 200)
    {
        switch (this.XHRObj.status){
            case 503:Display.status("dr.dk not available - please retry later");break;
            default:Display.status("Server Error " + this.XHRObj.status);
        }
    }
    else
    {
        if (this.videoLinkCallback)
        {
            this.videoLinkCallback(this.XHRObj.responseText);    // Notify all data is received and stored
        }
    }
}
Server.createVideoList = function(linkType)
{
    if (this.XHRObj.status != 200)
    {
        switch (this.XHRObj.status){
            case 503:Display.status("dr.dk not available - please retry later");break;
            default:Display.status("Server Error " + this.XHRObj.status);
        }
    }
    else
    {
        var jsontext = this.XHRObj.responseText;
        if(!jsontext){
            alert("Failed to get valid input");
        }
        else {
            var json = JSON.parse(jsontext);
            //var json = eval("(" + jsontext + ")");
            this.parseData(json, linkType);
        }
    }
}

Server.parseData = function(json, linkType)
{
    Data.init();
    //Loop through json elements
    for(i=0;i<json.length;i++){
        Data.description[i] = "";
        //alert("---------------");
        for(x in json[i]){
            if(x=="title"){
                //alert(i + " " + x + " " + json[i].title);
                Data.title[i] = json[i].title;
            }
            if(x=="description"){
                //alert(i + " " + x + " " + json[i].description);
                Data.description[i] = json[i].description + "<BR/><BR/>";
            }
            if(x=="spotSubTitle"){
                //alert(i + " " + x + " " + json[i].state);
                Data.description[i] = json[i].spotSubTitle + Data.description[i];
            }
            if(x=="slug" && Main.levels != 0){
                //alert(i + " " + x + " " + json[i].programSerieSlug);
                Data.link[i] = "http://www.dr.dk/nu/api/programseries/" + json[i].slug + "/videos";
                Data.slug[i] = json[i].slug;
            }
            if(x=="link"){
                //alert(i + " " + x + " " + json[i].link);
                Data.link[i] = json[i].link;
            }
            if(x=="videoManifestUrl"){
                //alert(i + " " + x + " " + json[i].link);
                Data.videoManifestUrl[i] = json[i].videoManifestUrl;
            }
            if(x=="id"){
                //alert(i + " " + x + " " + json[i].id);
                Data.id[i] = json[i].id;
            }
            if(x=="state"){
                //alert(i + " " + x + " " + json[i].state);
                Data.state[i] = json[i].state;
            }
            if(x=="broadcastTime"){
                if( (linkType == "modtitle") && Data.title[i]){
                    //alert("broadcasttime " + json[i][x])
                    var date_str = Server.dateMod(json[i][x]);
                    if(Data.title[i].indexOf("Deadline", 0) == 0){
                        Data.title[i] = "Deadline " + date_str;
                    }
                    if(Data.title[i].indexOf("TV AVISEN", 0) == 0){
                        Data.title[i] = "TV Avisen " + date_str;
                    }
                }
            }
            if(x=="formattedBroadcastTime"){
                //alert(i + " " + x + " " + json[i].state);
                Data.description[i] = Data.description[i] + "Udsendelsesdato: " + json[i].formattedBroadcastTime + "<BR/>";
            }
            if(x=="formattedExpireTime"){
                //alert(i + " " + x + " " + json[i].state);
                Data.description[i] = Data.description[i] + "Udl&oslash;bsdato: " + json[i].formattedExpireTime + "<BR/>";
            }
            if(x=="duration"){
                //alert(i + " " + x + " " + json[i].state);
                Data.description[i] = Data.description[i] + "Varighed: " + json[i].duration + "<BR/>";
            }
            if(x=="duration"){
                //alert(i + " " + x + " " + json[i].state);
                Data.description[i] = Data.description[i] + "Varighed: " + json[i].duration + "<BR/>";
            }
            if(x=="videoCount"){
                //alert(i + " " + x + " " + json[i].state);
                Data.description[i] = Data.description[i] + "Videoer: " + json[i].videoCount + "<BR/>";
            }
            //alert(x + ":" + json[i][x]);
        }
    }
    Data.videoCount = json.length;
    if (this.dataReceivedCallback)
    {
        this.dataReceivedCallback();    // Notify all data is received and stored
    }

}

Server.dateMod = function(date)
{
    var month_str = date.substring(5, 7);
    var day_str = date.substring(8, 10);
    if(day_str.charAt(0) == '0')
        day_str = day_str.charAt(1);
    switch(month_str){
        case "01":month_str = "januar";break;
        case "02":month_str = "februar";break;
        case "03":month_str = "marts";break;
        case "04":month_str = "april";break;
        case "05":month_str = "maj";break;
        case "06":month_str = "juni";break;
        case "07":month_str = "juli";break;
        case "08":month_str = "august";break;
        case "09":month_str = "september";break;
        case "10":month_str = "oktober";break;
        case "11":month_str = "november";break;
        case "12":month_str = "december";break;
    }
    
    var time_str = date.substring(11, 16);
    var output_str = time_str + " " + day_str + ". "+ month_str;
    //alert("broadcasttime mon " + month_str);
    //alert("broadcasttime day " + day_str);
    //alert("broadcasttime time " + time_str);
    return output_str;
}
