
var Fileio = 
{
    fs : null,
    HistoryMax : 1000,
    FavoritesMax : 20
}

var FileSettings = 
{
    initialBuffer : 12,
    pendingBuffer : 8,
    totalBuffer : 64,
    searchLimit : 100    
}

var Favorites =
{
    count : 0,
    next : 0,
    id: [ ],
    title: [ ],
    link : [ ],
    slug : [ ],
    videoManifestUrl : [ ],
    state : [ ]
}

var History =
{
    count : 0,
    next : 0,
    id: [ ],
    time: [ ],
    done: [ ]
}

Fileio.init = function()
{
    Fileio.fs = new FileSystem();
    if(Fileio.fs == null){
        alert("File system open failed");
        return 0;
    }else{
        return 1;
    }
}
Fileio.readSettings = function()
{
    var f = Fileio.fs.openCommonFile(curWidget.id + "/drdknu.cfg", 'r'); 
    if(f != null){
        var jsontxt = f.readAll();
        Fileio.fs.closeCommonFile(f);
        if(jsontxt != null){
            alert(jsontxt)
            //FileSettings = JSON.parse("[ " + jsontxt + " ]");
            FileSettings = JSON.parse(jsontxt);
            //return JSON.parse(jsontxt);
        }
    }else{
        alert("No settingsfile");
    }
    //Initialize settings if they don't exist
    if(typeof FileSettings.initialBuffer == 'undefined')
        FileSettings.initialBuffer = 12;
    if(typeof FileSettings.pendingBuffer == 'undefined')
        FileSettings.pendingBuffer = 8;
    if(typeof FileSettings.totalBuffer == 'undefined')
        FileSettings.totalBuffer = 64;
    if(typeof FileSettings.searchLimit == 'undefined')
        FileSettings.searchLimit = 100;
   
}
Fileio.writeSettings = function(settingsObj)
{
    var bValid = Fileio.fs.isValidCommonPath(curWidget.id); 
    if (!bValid) { 
        Fileio.fs.createCommonDir(curWidget.id);    
    }
    var f = Fileio.fs.openCommonFile(curWidget.id + "/drdknu.cfg", 'w'); 
    if(f != null){
        alert("Writing settings @ " + curWidget.id + "/drdknu.cfg");
        f.writeAll(JSON.stringify(settingsObj));
        Fileio.fs.closeCommonFile(f);    
    }
}

Fileio.writeFavorites = function(dataObj)
{
    var bValid = Fileio.fs.isValidCommonPath(curWidget.id); 
    if (!bValid) { 
        Fileio.fs.createCommonDir(curWidget.id);    
    }
    var f = Fileio.fs.openCommonFile(curWidget.id + "/fav.cfg", 'w'); 
    if(f != null){
        alert("Writing favorites @ " + curWidget.id + "/fav.cfg");
        f.writeAll(JSON.stringify(dataObj));
        Fileio.fs.closeCommonFile(f);    
    }
}
Fileio.readFavorites = function()
{
    var f = Fileio.fs.openCommonFile(curWidget.id + "/fav.cfg", 'r'); 
    if(f != null){
        var jsontxt = f.readAll();
        Fileio.fs.closeCommonFile(f);
        if(jsontxt != null){
            alert(jsontxt)
            Favorites = JSON.parse(jsontxt);
        }
    }else{
        alert("No favorites file");
    }
}

Fileio.writeHistory = function(dataObj)
{
    var bValid = Fileio.fs.isValidCommonPath(curWidget.id); 
    if (!bValid) { 
        Fileio.fs.createCommonDir(curWidget.id);    
    }
    var f = Fileio.fs.openCommonFile(curWidget.id + "/his.cfg", 'w'); 
    if(f != null){
        alert("Writing history @ " + curWidget.id + "/his.cfg");
        f.writeAll(JSON.stringify(dataObj));
        Fileio.fs.closeCommonFile(f);    
    }
}
Fileio.readHistory = function()
{
    var f = Fileio.fs.openCommonFile(curWidget.id + "/his.cfg", 'r'); 
    if(f != null){
        var jsontxt = f.readAll();
        Fileio.fs.closeCommonFile(f);
        if(jsontxt != null){
            alert(jsontxt)
            History = JSON.parse(jsontxt);
        }
    }else{
        alert("No history file");
    }
}

Fileio.addHistory = function(id, curTime, totTime)
{
    //Check to see if already present
    var hisIdx = Fileio.lookupHistory(id);
    var timeLeft = totTime - curTime;
    var update = false;
    if(hisIdx == -1){
        alert("History.next: " + History.next);
        if(History.next == undefined){
            alert("next undefined");
            History.next = 0;
        }else{
            if(++History.next>Fileio.HistoryMax){
                History.next = 0;
            }
        }
        hisIdx = History.next;
    }else{
        update = true;
    }
    alert("addHistory id:" + id + " curTime:" + curTime + " totTime:" + totTime + " timeleft:" + timeLeft);
    //We only store the video as played if played for more than 30 sec
    if(curTime>30000){
        if(timeLeft<60000){
            alert("Video marked as done");
            History.done[hisIdx] = true;
        }else{
            alert("Video marked as not done");
            History.done[hisIdx] = false;
        }
        History.id[hisIdx] = id;
        History.time[hisIdx] = curTime;
        if(!update){
            History.count = History.count + 1;
        }
        Fileio.writeHistory(History);
        alert("History saved at idx " + hisIdx);
    }else{
        alert("Video played for less than 30 sec - will not store in history");
    }
}

Fileio.lookupHistory = function(id)
{
    alert("lookupHistory ID:" + id);
    for(i=0; i<History.count;i++){
       if(History.id[i] == id){
           alert("lookupHistory found at idx:" + i);
           return i;
       } 
    }
    return -1;
}
